turtles-own [new? ]
globals [ len  string rotate-factor]

to startup
  setup
end

to setup
ca
reset-ticks
set string ""
 set len initial-length 
 set memory "" 
 ask patch 0 0  [sprout 1 
   [
   pd
   set pen-size 2
   set new? false
   set size 4
   set color yellow
   set heading 0
  ]
 ]
 tick
end

to -fd-
  ifelse pen-down? [
  #fd-len " pd fd  " ]
  [#fd-len " pu fd  "]
end

to #fd-len [#fd-len-command-string]
    set len initial-length
     set #fd-len-command-string (word #fd-len-command-string "len")
    ask turtles with [not new?] [run #fd-len-command-string]
    set memory (word memory  #fd-len-command-string)
    output-print memory
end

to -tilt-up-
  #tilt-up " tilt-up " 
end

to #tilt-up [#tilt-up-command-string]
  set angle angle
   set #tilt-up-command-string (word #tilt-up-command-string angle)
    ask turtles with [not new?] [run #tilt-up-command-string]
    set memory (word memory  #tilt-up-command-string)   
end

to -tilt-down-
  #tilt-down " tilt-down " 
end

to #tilt-down [#tilt-down-command-string]
  set angle angle
   set #tilt-down-command-string (word #tilt-down-command-string angle)
    ask turtles with [not new?] [run #tilt-down-command-string]
    set memory (word memory  #tilt-down-command-string)    
end

to -rt-
  #right " rt " 
end

to #right [#right-command-string]
  set angle angle
   set #right-command-string (word #right-command-string angle)
    ask turtles with [not new?] [run #right-command-string]
    set memory (word memory  #right-command-string) 
end

to -lt-
  #left " lt " 
end

to #left [#left-command-string]
  set angle angle
   set #left-command-string (word #left-command-string angle)
    ask turtles with [not new?] [run #left-command-string]
    set memory (word memory  #left-command-string)   
end
 
to -t-
#hatch " t "
end

to #hatch [#hatch-command-string]  
   ask turtles with [not new?] [run #hatch-command-string]
    set memory (word memory  #hatch-command-string)
end

to iterate
  cd
  set len len * scale-factor
  ask turtles with [not new?]
  [die]
  ask turtles with [new?] 
  [set new? false
    set size .1]
  ask turtles with [not new? ]  [ run memory]
  tick
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;Examples;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to dragon-curve
    ask patch 0 42  [sprout 1 
   [
   pd
   set pen-size 2
   set new? false
   set size 4
   set color yellow
   set heading 180
  ]
   ]
  dragon " lt 45 t  pd fd  len rt 45 rt 45 pd fd  len lt 45 lt 45 lt 45 lt 45 t "
end

to dragon [dragon-command-string]
  ifelse ticks = 1 [
     ask turtles with [not new?] [run dragon-command-string]
    set memory (word memory "\n" dragon-command-string) ]
  [
  cd
  set len len * .71
  ask turtles with [not new?]
  [die]
  ask turtles with [new?] 
  [set new? false
    set size .1]
  ask turtles with [not new? and color != blue]  [set color (color + 2) run memory]
  print memory
  ]
  tick
end

to levy-curve
  levy "lt 45 hatch 1 [set new? true set color green] fd len rt 45 rt 45 hatch 1 [set new? true set color green] fd len"
end

to levy [levy-command-string]
  ifelse ticks = 1 [
     ask turtles with [not new?] [run levy-command-string]
    set memory (word memory "\n" levy-command-string) ]
  [
  cd
  set len len * .71
  ask turtles with [not new?]
  [die]
  ask turtles with [new?] 
  [set new? false
    set size .1]
  ask turtles with [not new? and color != blue]  [set color (color + 2) run memory]
  print memory
  ]
  tick
end


to levy-tapestry
   ask patch 0 21  [sprout 1 
   [
   pd
   set pen-size 2
   set new? false
   set size 4
   set color yellow
   set heading 180
  ]
   ]
  levy-t "lt 45 hatch 1 [set new? true set color green] fd len rt 45 rt 45 hatch 1 [set new? true set color green] fd len"
end

to levy-t [levy-t-command-string]
  ifelse ticks = 1 [
     ask turtles with [not new?] [run levy-t-command-string]
    set memory (word memory "\n" levy-t-command-string) ]
  [
  cd
  set len len * .71
  ask turtles with [not new?]
  [die]
  ask turtles with [new?] 
  [set new? false
    set size .1]
  ask turtles with [not new? and color != blue]  [set color (color + 2) run memory]
  print memory
  ]
  tick
end

to Koch-curve
   Koch   "hatch 1 [set new? true set color green] fd len left 60 hatch 1 [set new? true set color green] fd len right 60 right 60 hatch 1 [set new? true set color green] fd len left 60 hatch 1 [set new? true set color green] fd len" 
end
  
to Koch [Koch-command-string]
      ifelse ticks = 1 [
     ask turtles with [not new?] 
     [ set heading 90 run Koch-command-string]
    set memory (word memory "\n" Koch-command-string) ]
  [
  cd
  set len len * .333
  ask turtles with [not new?]
  [die]
  ask turtles with [new?] 
  [set new? false
    set size .1]
  ask turtles with [not new?]  [set color (color + 2) run memory]
  print memory
  ]
  tick
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;fractal commands;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to t
hatch 1 [set new? true set color green]
end

to d
ask turtles with [not new?]
[ die ]
end


@#$#@#$#@
GRAPHICS-WINDOW
340
9
1016
706
55
55
6.0
1
10
1
1
1
0
1
1
1
-55
55
-55
55
0
0
1
ticks
30.0

BUTTON
40
95
184
157
NIL
setup\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
40
357
185
390
scale-factor
scale-factor
.01
2
0.71
.01
1
NIL
HORIZONTAL

BUTTON
40
397
185
465
NIL
iterate
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
218
336
332
369
NIL
Koch-curve
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
87
188
142
234
NIL
-fd-
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
87
277
142
320
NIL
-t-
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
218
368
332
401
NIL
Levy-curve
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
112
233
167
278
NIL
-rt-
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
58
233
113
278
NIL
-lt-
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
218
95
329
140
angle
angle
"30" "45" "60" "90" "custom-angle"
1

SLIDER
218
139
329
172
custom-angle
custom-angle
0
180
38
1
1
NIL
HORIZONTAL

SLIDER
218
171
329
204
initial-length
initial-length
0
50
15
1
1
NIL
HORIZONTAL

TEXTBOX
44
10
172
59
L-Systems
24
0.0
1

TEXTBOX
41
66
191
88
Procedures
18
0.0
1

TEXTBOX
221
65
371
87
Settings
18
0.0
1

TEXTBOX
221
312
371
334
Examples
18
0.0
1

TEXTBOX
171
249
209
268
Right
12
0.0
1

TEXTBOX
29
248
53
266
Left
12
0.0
1

TEXTBOX
84
324
184
343
Hatch Turtle
11
0.0
1

TEXTBOX
92
169
147
188
Forward
11
0.0
1

INPUTBOX
40
476
332
545
memory
NIL
1
0
String

SWITCH
218
203
329
236
pen-down?
pen-down?
0
1
-1000

BUTTON
218
400
332
433
NIL
levy-tapestry
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
218
432
332
465
NIL
dragon-curve
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

@#$#@#$#@
## WHAT IS IT?
Simple-L-system fractals is a model that illustrates how L-systems work. In this model a series of procedures are used to encode a string which is then run iteratively at different scales. Properties of fractals such as self-similarity and infinite length are evident in sample models and student models. Custom fractals can be made directly from the interface without the need to input code.

## HOW IT WORKS

In the interface window, press setup under Procedures and then try running one of the sample models under Examples by pressing the button Koch-curve. The generator for the Koch curve should appear in the view field. Press the button again and the fractal should iterate with regard to the scale factor set in the slider directly to the left of the Example buttons labelled scale-factor. You can also adjust the initial length for the line segment (the amount the turtle moves forward)  with the slider: initial-length under Settings. Just remember to press Setup again after you make any adjustments. For the Koch curve, the scale-factor should be set to (.333). That means for every subsequent iteration the initial line segment will divide into three smaller segments of equal length. Note: for the Koch curve, because the initial fractal consists of four lines, for subsequent iterations each line will morph into a smaller version of the initial four line fractal — only at 1/3 the size of the original. 

## HOW TO USE IT

To design a fractal, first press setup. A yellow turtle should appear in the middle of the view screen. Use the L-system symbols, modeled with buttons and sliders, to move the  turtle around. The turtle can be turned to the right (r) or left (l) by the angle amount set in the chooser angle and moved forward (f) by the amount specified with the slider initial-length. One more thing — a new turtle can be hatched with the hatch-turtle button (t) at any point in your process. This new turtle will be colored green. Green turtles will run the L-system you design at the scale-factor when you press iterate. The yellow turtle will disappear. Make sure to hatch new turtles as you design your fractal so that it will be able to reproduce itself. 

## THINGS TO NOTICE

Notice in the interface the L-system string is printed as you choose procedures. This string represents the scale-invariant algorithm which defines your fractal and stays the same as subsequent iterations create a more complex pattern. An interesting feature of fractals is that, theoretically at least, iterations can continue indefinitely.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0RC4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
